//////////////////////////////////////////////////////////////////////
// heightmap.cpp     by Tobias Franke (webmaster@cyberhead.de) 2001 //
//////////////////////////////////////////////////////////////////////

#include "heightmap.h"

heightmap::heightmap(void)
{
	hmap = 0;
	width=height=0;
}

bool heightmap::create(int x, int y)
{
	hmap = new float[x*y];
	if (hmap)
	{
		width=x; height=y;
		return true;
	}
	else
		return false;
}

bool heightmap::load(char *filename)
{
	bitmap map;
	
	if (!map.load (filename)) return false;

	int w = map.getwidth();
	int h = map.getheight();

	create (w, h);

	if (hmap) 
	{
		for (int z=0; z<h; z++) 
			for (int x=0; x<w; x++)
			{
				hmap[x+(z*width)]=map.data[(x+(z*w))*3 + 1];	//Check for green value
			}
		return true;
	}
	else return false;
}

bool heightmap::save(char *filename)
{
	BYTE color;
	bitmap map;

	if (!map.create (width, height)) return false;

	if (hmap)
	{
		for (int z=0; z<height; z++)
			for (int x=0; x<width; x++)
			{
				color=(unsigned)hmap[x+(z*width)];	
				map.setcolor(x, z, color, color, color);
			}
		if (!map.save (filename)) return false;
		return true;
	}
	else return false;
}

void heightmap::reset(void)
{
	if (hmap)
	{
		delete hmap;
		width=height=0;
	}
}

heightmap::~heightmap(void)
{
	if (hmap)
		delete hmap;
	hmap = 0;
}